routes/web.php
<?php

use App\Http\Controllers\AlumnoController;
use App\Http\Controllers\CursoController;
use App\Http\Controllers\PerteneceController;
use App\Http\Controllers\PracticaController;
use App\Http\Controllers\PresentaController;
use Illuminate\Support\Facades\Route;

Route::get('/', function () {
    return view('index');
})->name('inicio');

//enrutamiento controlador alumno
Route::resource('alumno', AlumnoController::class);

//enrutammiento controlador curso
Route::resource('curso', CursoController::class);

//enrutamiento controlador practica
Route::resource('practica', PracticaController::class);

//enrutamiento controlador presentacion
Route::resource('presenta', PresentaController::class);


//enrutamiento controlador pertenece
Route::resource('pertenece', PerteneceController::class);

//enrutamiento adicional para practicas
Route::controller(PracticaController::class)->group(function () {
    Route::get('practica/confirmar/{practica}', 'confirmar')
        ->name('practica.confirmar');
});

app/Models/Curso.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Support\Facades\Schema;

class Curso extends Model
{
    use HasFactory;

    //nombre de la tabla
    protected $table = 'cursos';

    //campos de asignacion masiva
    protected $fillable = [
        'nombre',
        'fechacomienzo',
        'duracion',
        'observaciones',
    ];

    //creamos atributo estatico con los labels
    public static $labels = [
        'id' => 'ID del curso',
        'nombre' => 'Nombre',
        'fechacomienzo' => 'Fecha de comienzo',
        'duracion' => 'Duración (horas)',
        'observaciones' => 'Observaciones',
    ];

    //metodo para devolver el label de un campo
    public function getAttributeLabel($key)
    {
        return self::$labels[$key] ?? $key;
    }

    //metodo para devolver todos los campos
    public function getFields()
    {
        return Schema::getColumnListing($this->table);
    }

    //voy a crear las relaciones entre tablas

    //como la relacion es de muchos se pone en plural
    public function perteneces(): HasMany
    {
        //pertenece a muchos y devuelve la ruta de la relacion
        return $this->hasMany(Pertenece::class);
    }

    //relacion uno a muchos
    public function presentas(): HasMany
    {
        return $this->hasMany(Presenta::class);
    }
}

app/Http/Controllers/CursoController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\CursoRequest;
use App\Models\Curso;
use Illuminate\Http\Request;

class CursoController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        //sacamos los cursos
        $cursos=Curso::all();
        return view('curso.index',compact('cursos'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('curso.create', [
            'curso' => new Curso()
        ]);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(CursoRequest $request)
    {
        //crear el curso
        $curso=Curso::create($request->all());
        //redirigir
        return redirect()
        ->route('curso.show', $curso->id)
        ->with('success','Curso creado con exito');
    }

    /**
     * Display the specified resource.
     */
    public function show(Curso $curso)
    {
        return view('curso.show',compact('curso'));
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Curso $curso)
    {
        return view('curso.edit',compact('curso'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(CursoRequest $request, Curso $curso)
    {
        ///actualizar el curso
        $curso->update($request->all());
        //redirigir
        return redirect()
        ->route('curso.index', $curso)
        ->with('success','Curso actualizado con exito');
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Curso $curso)
    {
        
        //eliminamos el curso
        $curso->delete();
        //redirigir
        return redirect()
        ->route('curso.index')
        ->with('success','Curso eliminado con exito');
    }
}

resources/views/curso/_form.blade.php
<div>
    <label for="nombre">Nombre</label>
    <input type="text" name="nombre" id="nombre" value="{{ old('nombre', $curso->nombre) }}">
    @error('nombre')
        <div class="error">{{ $message }}></div>
    @enderror
</div>
<div>
    <label for="fechacomienzo">Fecha de comienzo</label>
    <input type="date" name="fechacomienzo" id="fechacomienzo"
        value="{{ old('fechacomienzo', $curso->fechacomienzo) }}">
    @error('fechacomienzo')
        <div class="error">{{ $message }}</div>
    @enderror
</div>
<div>
    <label for="duracion">Duracion</label>
    <input type="number" name="duracion" id="duracion" value="{{ old('duracion', $curso->duracion) }}">
    @error('duracion')
        <div class="error">{{ $message }}</div>
    @enderror
</div>
<div>
    <label for="observaciones">Observaciones</label>
    <input type="text" name="observaciones" id="observaciones"
        value="{{ old('observaciones', $curso->observaciones) }}">
    @error('observaciones')
        <div class="error">{{ $message }}</div>
    @enderror
</div>
<div>
    <button type="submit" class="boton">Guardar</button>
</div>

resources/views/curso/create.blade.php
@extends('layouts.main')

@section('content')
    <div>
        <h1>Crear nuevo curso</h1>
    </div>
    <form action="{{ route('curso.store') }}" method="post">
        @csrf
        @include('curso._form')
    </form>
@endsection

resources/views/curso/edit.blade.php
@extends('layouts.main')

@section('content')
    <div>
        <h1>Actualizar curso</h1>
    </div>
    <form action="{{ route('curso.update',$curso) }}" method="post">
        @csrf
        @method('PUT')
        @include('curso._form')
    </form>
@endsection

resources/views/curso/index.blade.php
@extends('layouts.main')

@section('content')
    <h1>Cursos</h1>
<div class="listado">
    @foreach ($cursos as $curso)
        <div class="tarjeta">
            <ul>
                <li>{{ $curso->id }}</li>
                <li>Nombre: {{ $curso->nombre }}</li>
                <li>Fecha de comienzo: {{ $curso->fechacomienzo }}</li>
                <li>Duracion: {{ $curso->duracion }}</li>
                <li>Observaciones: {{ $curso->observaciones }}</li>
            </ul>
            <div class="botones">
                <a href="{{ route('curso.show', $curso->id) }}" class="boton">Ver</a>
                <a href="{{ route('curso.edit', $curso->id) }}" class="boton">Editar</a>
                <form action="{{ route('curso.destroy', $curso) }}" method="post" id="eliminar" class="form-inline">
                    @csrf
                    @method('delete')
                    <button type="submit" class="boton">Borrar</button>
                </form>
            </div>
        </div>
    @endforeach
</div>
@endsection

resources/views/curso/show.blade.php
@extends('layouts.main')

@section('content')
<div class="tarjeta">
    <ul>
        <li>Nombre: {{ $curso->nombre }}</li>
        <li>Fecha de comienzo: {{ $curso->fechacomienzo }}</li>
        <li>Duracion: {{ $curso->duracion }}</li>
        <li>Observaciones: {{ $curso->observaciones }}</li>
    </ul>
    <div class="botones">
        <a href="{{ route('curso.edit', $curso->id) }}" class="boton">Editar</a>
        <form action="{{ route('curso.destroy', $curso) }}" method="post" id="eliminar">
            @csrf
            @method('DELETE')
            <button type="submit" class="boton">Borrar</button>
        </form>
    </div>
</div>
@endSection